Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jdt.core.jdom
Interface IDOMNode

All Superinterfaces:
  Cloneable

All Known Subinterfaces:
  IDOMCompilationUnit, IDOMField, IDOMImport, IDOMInitializer, IDOMMember, IDOMMethod, IDOMPackage, IDOMType

Deprecated. The JDOM was made obsolete by the addition in 2.0 of the more powerful, fine-grained DOM/AST API found in the org.eclipse.jdt.core.dom package.

public interface IDOMNode
extends Cloneable

Nodes represent structural fragments of a Java source file, also known as document fragments. Their implementation is known as a DOM (Document Object Model) - in this case a JDOM (Java DOM). A root node (node with no parent or siblings) represents the root of a document fragment (DF). A complete Java document is represented by a compilation unit node (`IDOMCompilationUnit`). In this way, a DF is comprised of DFs, and a document itself (compilation unit) is also a DF.

A DF may be created empty and programmatically filled, or it may be created from a source code string. The `IDOMFactory` allows the creation of all kinds of nodes from source code strings. Manipulations performed on a DF are immediately reflected in the DF's contents.

Children fragments are represented as a linked list of nodes. Children are inserted via their parent node, and are automatically linked up with previous and next nodes.

The contents of any node (DF) may be retrieved at any time. In this way it is possible to retrieve source code representing fragments of the compilation unit (for example, a type or a method), since the contents of any node (not just the root node) may be obtained.

The following manipulations on DFs are distinct:

- clone - this creates a stand-alone copy of the DF that is in no way dependent on the DF that it was cloned from
- remove - this orphans a DF from its host DF. The removed DF may still be dependent on its previous host (perhaps to generate its contents), and hanging onto the fragment means that its previous host is also retained in memory.
- add/insert - this splices an un-parented DF (one that has been cloned, removed, or created stand-alone), into an existing DF such that the newly inserted DF is only dependent on its new host.

Wherever types are specified in DOM APIs, type names must be specified as they would appear in source code. The DOM does not have a notion of type signatures, only raw text. Example type names are `"Object"`, `"java.io.File"`, and `"int[]"`.

This interface is not intended to be implemented by clients.

Field Summary
`static int` | `COMPILATION_UNIT` Deprecated. Node type constant indicating a compilation unit.
`static int` | `FIELD` Deprecated. Node type constant indicating a field declaration.
`static int` | `IMPORT` Deprecated. Node type constant indicating an import declaration.
`static int` | `INITIALIZER` Deprecated. Node type constant indicating an initializer declaration.
`static int` | `METHOD` Deprecated. Node type constant indicating a method (or constructor) declaration.
`static int` | `PACKAGE` Deprecated. Node type constant indicating a package declaration.
`static int` | `TYPE` Deprecated. Node type constant indicating a type declaration.

Method Summary
`void` | `addChild(IDOMNode child)` Deprecated. Adds the given un-parented node (document fragment) as the last child of this node.
`boolean` | `canHaveChildren()` Deprecated. Returns whether this node is allowed to have children.
`Object` | `clone()` Deprecated. Returns a stand-alone copy of the document fragment represented by this node that is in no way dependent on the document this node is part of.
`char[]` | `getCharacters()` Deprecated. Returns the current contents of this document fragment as a character array.
`IDOMNode` | `getChild(String name)` Deprecated. Returns the first named child of this node with the given name.
`Enumeration` | `getChildren()` Deprecated. Returns an enumeration of children of this node.
`String` | `getContents()` Deprecated. Returns the current contents of this document fragment.
`IDOMNode` | `getFirstChild()` Deprecated. Returns the first child of this node.
`IJavaElement` | `getJavaElement(IJavaElement parent)` Deprecated. Returns a handle for the Java element associated with this document fragment, based on the parent Java element.
`String` | `getName()` Deprecated. Returns the name of this node.
`IDOMNode` | `getNextNode()` Deprecated. Returns the sibling node immediately following this node.
`int` | `getNodeType()` Deprecated. Returns the type of this node.
`IDOMNode` | `getParent()` Deprecated. Returns the parent of this node.
`IDOMNode` | `getPreviousNode()` Deprecated. Returns the sibling node immediately preceding this node.
`void` | `insertSibling(IDOMNode sibling)` Deprecated. Inserts the given un-parented node as a sibling of this node, immediately before this node.
`boolean` | `isAllowableChild(IDOMNode node)` Deprecated. Returns whether the given node is an allowable child for this node.
`boolean` | `isSignatureEqual(IDOMNode node)` Deprecated. Returns whether this node's signature is equivalent to the given node's signature.
`void` | `remove()` Deprecated. Separates this node from its parent and siblings, maintaining any ties that this node has to the underlying document fragment.
`void` | `setName(String name)` Deprecated. Sets the name of this node.

Field Detail

### COMPILATION_UNIT

    public static final int COMPILATION_UNIT

  Deprecated.
  Node type constant indicating a compilation unit. Nodes of this type maybe by safely cast to `IDOMCompilationUnit`.

  See Also:
    `getNodeType()`, Constant Field Values

### PACKAGE

    public static final int PACKAGE

  Deprecated.
  Node type constant indicating a package declaration. Nodes of this type maybe by safely cast to `IDOMPackage`.

  See Also:
    `getNodeType()`, Constant Field Values

### IMPORT

    public static final int IMPORT

  Deprecated.
  Node type constant indicating an import declaration. Nodes of this type maybe by safely cast to `IDOMImport`.

  See Also:
    `getNodeType()`, Constant Field Values

### TYPE

    public static final int TYPE

  Deprecated.
  Node type constant indicating a type declaration. Nodes of this type maybe by safely cast to `IDOMType`.

  See Also:
    `getNodeType()`, Constant Field Values

### FIELD

    public static final int FIELD

  Deprecated.
  Node type constant indicating a field declaration. Nodes of this type maybe by safely cast to `IDOMField`.

  See Also:
    `getNodeType()`, Constant Field Values

### METHOD

    public static final int METHOD

  Deprecated.
  Node type constant indicating a method (or constructor) declaration. Nodes of this type maybe by safely cast to `IDOMMethod`.

  See Also:
    `getNodeType()`, Constant Field Values

### INITIALIZER

    public static final int INITIALIZER

  Deprecated.
  Node type constant indicating an initializer declaration. Nodes of this type maybe by safely cast to `IDOMInitializer`.

  See Also:
    `getNodeType()`, Constant Field Values

Method Detail

### addChild

    public void addChild(IDOMNode child)
                  throws DOMException,
                         IllegalArgumentException

  Deprecated.
  Adds the given un-parented node (document fragment) as the last child of this node.

  Parameters:
    `child` - the new child node
  Throws:
    `DOMException` - if any of the following conditions hold:
    - this node is not allowed to have children,
    - the child is not of an allowable type
    - the child already has a parent
    - the child is an ancestor of this node
    `IllegalArgumentException` - if the child is `null`
  See Also:
    `insertSibling(IDOMNode)`, `remove()`

### canHaveChildren

    public boolean canHaveChildren()

  Deprecated.
  Returns whether this node is allowed to have children.

  Returns:
    `true` if this node can have children

### clone

    public Object clone()

  Deprecated.
  Returns a stand-alone copy of the document fragment represented by this node that is in no way dependent on the document this node is part of.

  Returns:
    a copy of type `IDOMNode`
  See Also:
    `addChild(IDOMNode)`, `insertSibling(IDOMNode)`, `remove()`

### getCharacters

    public char[] getCharacters()

  Deprecated.
  Returns the current contents of this document fragment as a character array.

  Note: To obtain complete source for the ".java" file, ask a compilation unit node for its contents.

  Returns:
    the contents, or `null` if this node has no contents

### getChild

    public IDOMNode getChild(String name)

  Deprecated.
  Returns the first named child of this node with the given name.

  Parameters:
    `name` - the name
  Returns:
    the child node, or `null` if no such child exists

### getChildren

    public Enumeration getChildren()

  Deprecated.
  Returns an enumeration of children of this node. Returns an empty enumeration if this node has no children (including nodes that cannot have children). Children appear in the order in which they are declared in the source code.

  Returns:
    an enumeration of the children

### getContents

    public String getContents()

  Deprecated.
  Returns the current contents of this document fragment.

  Note: To obtain complete source for the ".java" file, ask a compilation unit node for its contents.

  Returns:
    the contents, or `null` if this node has no contents

### getFirstChild

    public IDOMNode getFirstChild()

  Deprecated.
  Returns the first child of this node. Children appear in the order in which they exist in the source code.

  Returns:
    the first child, or `null` if this node has no children
  See Also:
    `getChildren()`

### getJavaElement

    public IJavaElement getJavaElement(IJavaElement parent)
                                throws IllegalArgumentException

  Deprecated.
  Returns a handle for the Java element associated with this document fragment, based on the parent Java element.

  Parameters:
    `parent` - the parent Java element
  Returns:
    a handle for the Java element associated with this document fragment, based on the parent Java element
  Throws:
    `IllegalArgumentException` - if the parent element is not of a valid parent type for this node

### getName

    public String getName()

  Deprecated.
  Returns the name of this node. More details are provided in each of the subtypes.

  Returns:
    the name, or `null` if it has no name

### getNextNode

    public IDOMNode getNextNode()

  Deprecated.
  Returns the sibling node immediately following this node.

  Returns:
    the next node, or `null` if there is no following node

### getNodeType

    public int getNodeType()

  Deprecated.
  Returns the type of this node.

  Returns:
    one of the node type constants defined in `IDOMNode`

### getParent

    public IDOMNode getParent()

  Deprecated.
  Returns the parent of this node.

  Returns:
    the parent node, or `null` if this node does not have a parent

### getPreviousNode

    public IDOMNode getPreviousNode()

  Deprecated.
  Returns the sibling node immediately preceding this node.

  Returns:
    the previous node, or `null` if there is no preceding node

### insertSibling

    public void insertSibling(IDOMNode sibling)
                       throws DOMException,
                              IllegalArgumentException

  Deprecated.
  Inserts the given un-parented node as a sibling of this node, immediately before this node.

  Parameters:
    `sibling` - the new sibling node
  Throws:
    `DOMException` - if any of the following conditions hold:
    - this node is a document fragment root
    - the sibling is not of the correct type
    - the sibling already has a parent
    - this sibling is an ancestor of this node
    `IllegalArgumentException` - if the sibling is `null`
  See Also:
    `addChild(IDOMNode)`, `clone()`, `remove()`

### isAllowableChild

    public boolean isAllowableChild(IDOMNode node)

  Deprecated.
  Returns whether the given node is an allowable child for this node.

  Parameters:
    `node` - the potential child node
  Returns:
    `true` if the given node is an allowable child

### isSignatureEqual

    public boolean isSignatureEqual(IDOMNode node)

  Deprecated.
  Returns whether this node's signature is equivalent to the given node's signature. In other words, if the nodes were siblings, would the declarations collide because they represent the same declaration.

  Parameters:
    `node` - the other node
  Returns:
    `true` if the nodes have equivalent signatures

### remove

    public void remove()

  Deprecated.
  Separates this node from its parent and siblings, maintaining any ties that this node has to the underlying document fragment. A document fragment that is removed from its host document may still be dependent on that host document until it is inserted into a different document. Removing a root node has no effect.

  See Also:
    `addChild(IDOMNode)`, `clone()`, `insertSibling(IDOMNode)`

### setName

    public void setName(String name)

  Deprecated.
  Sets the name of this node. Name format depends on node type. More details are provided in each of the subtypes.

  Parameters:
    `name` - the name, or `null` to clear the name

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) IBM Corp. and others 2000, 2004. All Rights Reserved.